import { useCallback, useEffect, useState } from "react";
import noop from "lodash/fp/noop";
var useBehaviorSubject = function (subject$, fn) {
    var callback = useCallback(fn || noop, []);
    var _a = useState(subject$.value), val = _a[0], setVal = _a[1];
    useEffect(function () {
        var subscription = subject$.subscribe(function (val) {
            callback(val);
            setVal(val);
        });
        return function () {
            subscription.unsubscribe();
        };
    }, [callback, subject$]);
    return [val, subject$.next.bind(subject$)];
};
export default useBehaviorSubject;
