import { BehaviorSubject } from "rxjs";
/**
 * Wrapper around `rxjs.BehaviorSubject`.
 *
 * @param   subject$  The behavior subject
 * @param   fn        The callback
 * @returns BehaviorSubjectState
 */
export declare type UseBehaviorSubject = <T>(subject$: BehaviorSubject<T>, fn?: BehaviorSubjectFn<T>) => BehaviorSubjectState<T>;
export declare type BehaviorSubjectState<T> = [T, BehaviorSubjectFn<T>];
/**
 * Callback used for subscription.
 *
 * @param val T
 * @returns void
 */
export declare type BehaviorSubjectFn<T> = (val: T) => void;
