var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { useEffect } from "react";
import { defaultOpts } from "./click-outside.types";
var isOutside = function (target, source) {
    if (!(target instanceof Node))
        return false;
    if (!(source instanceof Node))
        return false;
    if (source.isEqualNode(target))
        return false;
    if (source.contains(target))
        return false;
    return true;
};
export var useClickOutside = function (ref, fn, overrideOpts) {
    if (overrideOpts === void 0) { overrideOpts = {}; }
    var opts = Object.assign(defaultOpts, overrideOpts);
    useEffect(function () {
        var currRoot = opts.root.current || document;
        var listener = function (evt) {
            var isBetweenRootAndTarget = __spreadArrays([ref], opts.except).every(function (el) {
                var isInsideRoot = !isOutside(evt.target, currRoot);
                var isOutsideOfTarget = isOutside(evt.target, el.current);
                return isInsideRoot && isOutsideOfTarget;
            });
            if (isBetweenRootAndTarget) {
                fn(evt);
            }
        };
        currRoot.addEventListener(opts.listenerType, listener, opts.listenerOpts);
        return function () { return currRoot.removeEventListener(opts.listenerType, listener, opts.listenerOpts); };
    }, [fn, opts, ref]);
};
export default useClickOutside;
