import { ToggleState } from "../toggle";
/**
 * A wrapper around `useInterval`.
 *
 * @param   fn    Interval handler
 * @param   opts  Interval options
 * @returns       A toggle state
 */
export declare type UseInterval = (fn: IntervalFn, opts?: number | Partial<IntervalOpts>) => ToggleState;
export declare type IntervalFn = () => void;
export declare type IntervalOpts = {
    /**
     * `setInterval` delay.
     *
     * @default 1000
     */
    delay: number;
    /**
     * Should start the interval on mount.
     *
     * @default false
     */
    autoStart: boolean;
};
export declare const defaultOpts: IntervalOpts;
