import { useCallback, useEffect } from "react";
var useSubject = function (subject, fn) {
    var callback = useCallback(fn, []);
    useEffect(function () {
        var subscription = subject.subscribe(callback);
        return function () { return subscription.unsubscribe(); };
    }, [callback, subject]);
};
export default useSubject;
