import { Subject } from "rxjs";
/**
 * Wrapper around `rxjs.Subject`.
 *
 * @param subject The subject
 * @param fn The callback used for subscription
 * @returns void
 */
export declare type UseSubject = <T>(subject$: Subject<T>, fn: SubjectFn<T>) => void;
/**
 * Callback used for subscription.
 *
 * @param val T
 * @returns void
 */
export declare type SubjectFn<T> = (val: T) => void;
